//THE FILE IS GENERATED, DO NOT MODIFY IT MANUALLY!!!
package tech.carpentum.sdk.payment.internal.generated.model;

import com.squareup.moshi.JsonClass;
import java.util.Objects;
import java.util.Optional;
import org.jetbrains.annotations.NotNull;
import tech.carpentum.sdk.payment.internal.generated.model.*;
import tech.carpentum.sdk.payment.model.*;

/** IdPayment
 *
 * The Unique reference ID of the Order generated by platform. It is alphanumeric and max length is 250 characters.
 *
 * 
 *
 * The model class is immutable.
 *
 * Use static {@link #of} method to create a new model class instance.
 */
@JsonClass(generateAdapter = false)
public class IdPaymentImpl implements IdPayment {
    private final @NotNull String value;

    private final int hashCode;
    private final String toString;

    public IdPaymentImpl(@NotNull String value) {
        this.value = Objects.requireNonNull(value, "Property 'IdPayment' is required.");

        this.hashCode = value.hashCode();
        this.toString = String.valueOf(value);
    }

    @Override
    public String getValue() {
        return value;
    }

    @Override
    public String toString() {
        return toString;
    }

    @Override
    public int hashCode() {
        return hashCode;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }

        if (!(obj instanceof IdPaymentImpl)) {
            return false;
        }

        IdPaymentImpl that = (IdPaymentImpl) obj;
        if (!this.value.equals(that.value)) return false;

        return true;
    }
}